#pragma semicolon 1
#include <sourcemod>

public Plugin:myinfo = 
{
	name = "New Year Seconds",
	author = "wS / Schmidt",
	description = "Сколько осталось сек до Нового Года",
	version = "1.0",
	url = "http://world-source.ru/"
};

new Handle:g_Timer = INVALID_HANDLE;
new Handle:g_new_year_timestamp;
new String:g_Msg[150];
new bool:g_NewYear = false;

public OnPluginStart()
{
	g_new_year_timestamp = CreateConVar("new_year_timestamp", "1356998401", "timestamp начала Нового Года", FCVAR_NOTIFY);
	HookConVarChange(g_new_year_timestamp, cvar_changed);
}

///

public cvar_changed(Handle:cvar, const String:OldValue[], const String:NewValue[])
{
	wS_Kill_Timer();
	wS_StartTimer();
}

wS_Kill_Timer()
{
	g_NewYear = false;
	if (g_Timer != INVALID_HANDLE)
	{
		KillTimer(g_Timer);
		g_Timer = INVALID_HANDLE;
	}
}

///

wS_StartTimer()
{
	g_Timer = CreateTimer(1.0, wS_StartTimer_CallBack, GetConVarInt(g_new_year_timestamp), TIMER_REPEAT | TIMER_FLAG_NO_MAPCHANGE);
}

public Action:wS_StartTimer_CallBack(Handle:timer, any:NewYearSec)
{
	if (!g_NewYear)
	{
		new sec = NewYearSec - GetTime();
		if (sec > 0) Format(g_Msg, 150, "До Нового Года осталось:\n%d сек", sec);
		else
		{
			strcopy(g_Msg, 150, "С Новым Годом!!!");
			g_NewYear = true;
		}
	}

	new Handle:Message = StartMessageAll("KeyHintText");
	if (Message != INVALID_HANDLE)
	{
		BfWriteByte(Message, 1);
		BfWriteString(Message, g_Msg);
		EndMessage();
	}

	return Plugin_Continue;
}

bool:wS_PlayerInServer(ignore_client)
{
	static i;
	for (i = 1; i <= MaxClients; i++)
	{
		if (i != ignore_client && IsClientInGame(i)) return true;
	}
	return false;
}

///

public OnClientDisconnect(client)
{
	if (!wS_PlayerInServer(client)) wS_Kill_Timer();
}

public OnClientPutInServer(client)
{
	if (g_Timer == INVALID_HANDLE) wS_StartTimer();
}